<?php

	/*
	Plugin Name: Comments On Feed
	Plugin URI: http://www.moallemi.ir/en/blog/2009/12/18/comments-on-feed-for-wordpress/
	Description: This plugin lets you show each post comments on post feed.
	Version: 0.7.0.1
	Author: Reza Moallemi
	Author URI: http://www.moallemi.ir/blog
	*/

	load_plugin_textdomain('comments-on-feed', NULL, dirname(plugin_basename(__FILE__)) . "/languages");
	
	add_action('admin_menu', 'comments_on_feed_menu');

	function comments_on_feed_menu() 
	{
		add_options_page('Comments On Feed Options', __('Comments On Feed', 'comments-on-feed'), 8, 'comments-on-feed', 'comments_on_feed_options');
	}

	function get_comments_on_feed_options()
	{
		$comments_on_feed_options = array('show_avatar' => 'true',
								'avatar_size' => '32',
								'comment_number' => '5',
								'comment_order' => 'ASC');
		$comments_on_feed_save_options = get_option('comments_on_feed_options');
		if (!empty($comments_on_feed_save_options))
		{
			foreach ($comments_on_feed_save_options as $key => $option)
			$comments_on_feed_options[$key] = $option;
		}
		update_option('comments_on_feed_options', $comments_on_feed_options);
		return $comments_on_feed_options;
	}
	
	
	function CommentsOnFeed() 
	{
		add_filter('the_content', 'add_comments_to_feed', 9999);
	}

	function comments_on_feed_options()
	{
		$comments_on_feed_options = get_comments_on_feed_options();
		if (isset($_POST['update_comments_on_feed_settings']))
		{
			$comments_on_feed_options['show_avatar'] = isset($_POST['show_avatar']) ? $_POST['show_avatar'] : 'false';
			$comments_on_feed_options['avatar_size'] = isset($_POST['avatar_size']) ? $_POST['avatar_size'] : '32';
			$comments_on_feed_options['comment_number'] = (isset($_POST['comment_number']) and $_POST['comment_number'] != '') ? intval($_POST['comment_number']) : '5';
			$comments_on_feed_options['comment_order'] = isset($_POST['comment_order']) ? $_POST['comment_order'] : 'ACS';

			update_option('comments_on_feed_options', $comments_on_feed_options);
			?>
			<div class="updated">
				<p><strong><?php _e("Settings Saved.","comments-on-feed");?></strong></p>
			</div>
			<?php
		} ?>
		<div class=wrap>
		<?php if(function_exists('screen_icon')) screen_icon(); ?>
			<form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>">
				<h2><?php _e('Comments On Feed Settings', 'comments-on-feed'); ?></h2>
				<h3><?php _e('General Settings:', 'comments-on-feed'); ?></h3>
				<p><input name="show_avatar" value="true" type="checkbox" <?php if ($comments_on_feed_options['show_avatar'] == 'true' ) echo ' checked="checked" '; ?> /> <?php _e('Show Avatar.', 'comments-on-feed'); ?></p>
				<p><?php _e('Avatar Size:', 'comments-on-feed'); ?> 
					<select name="avatar_size">
					  <option value="32" <?php if ($comments_on_feed_options['avatar_size'] == '32' ) echo ' selected="selected" '; ?> >32 px</option>
					  <option value="16" <?php if ($comments_on_feed_options['avatar_size'] == '16' ) echo ' selected="selected" '; ?> >16 px</option>
					</select>
				</p>
				<p><?php _e('Number of comments to show on each feed item: ', 'comments-on-feed'); ?> 
					<input style="width:25px;" name="comment_number" type="text" value="<?php echo $comments_on_feed_options['comment_number']; ?>" /> 
					<small><?php _e('Set the value to <b>0</b> if you want to show all comments.', 'comments-on-feed'); ?></small>
				</p>
				<p><?php _e('Comments Order:', 'comments-on-feed'); ?> 
					<select name="comment_order">
					  <option value="ASC" <?php if ($comments_on_feed_options['comment_order'] == 'ASC' ) echo ' selected="selected" '; ?> ><?php _e('Oldest first', 'comments-on-feed'); ?></option>
					  <option value="DESC" <?php if ($comments_on_feed_options['comment_order'] == 'DESC' ) echo ' selected="selected" '; ?> ><?php _e('Newest first', 'comments-on-feed'); ?></option>
					</select>
				</p>
				<div class="submit">
					<input type="submit" name="update_comments_on_feed_settings" value="<?php _e('Save Changes', 'comments-on-feed') ?>" />
				</div>
				<hr />
				<div>
					<h4><?php _e('My other plugins for wordpress:', 'comments-on-feed'); ?></h4>
					<ul>
						<li><b>- <?php _e('Google Transliteration ', 'comments-on-feed'); ?></b>
							(<a href="http://wordpress.org/extend/plugins/google-transliteration/"><?php _e('Download', 'comments-on-feed'); ?></a> | 
							<a href="<?php _e('http://www.moallemi.ir/en/blog/2009/10/10/google-transliteration-for-wordpress/', 'comments-on-feed'); ?>"><?php _e('More Information', 'comments-on-feed'); ?></a>)
						</li>
						<li><b>- <?php _e('Behnevis Transliteration ', 'comments-on-feed'); ?></b> 
							(<a href="http://wordpress.org/extend/plugins/behnevis-transliteration/"><?php _e('Download', 'comments-on-feed'); ?></a> | 
							<a href="http://www.moallemi.ir/blog/1388/07/25/%D8%A7%D9%81%D8%B2%D9%88%D9%86%D9%87-%D9%86%D9%88%DB%8C%D8%B3%D9%87-%DA%AF%D8%B1%D8%AF%D8%A7%D9%86-%D8%A8%D9%87%D9%86%D9%88%DB%8C%D8%B3-%D8%A8%D8%B1%D8%A7%DB%8C-%D9%88%D8%B1%D8%AF%D9%BE%D8%B1%D8%B3/"><?php _e('More Information', 'comments-on-feed'); ?></a> )
						</li>
						<li>- <b><?php _e('Advanced User Agent Displayer ', 'comments-on-feed'); ?></b>
							(<a href="http://wordpress.org/extend/plugins/comments-on-feed/"><?php _e('Download', 'comments-on-feed'); ?></a> | 
							<a href="<?php _e('http://www.moallemi.ir/en/blog/2009/09/20/comments-on-feed/', 'comments-on-feed'); ?>"><?php _e('More Information', 'comments-on-feed'); ?></a>)
						</li>
						<li><b>- <?php _e('Feed Delay ', 'comments-on-feed'); ?></b> 
							(<a href="http://wordpress.org/extend/plugins/feed-delay/"><?php _e('Download', 'comments-on-feed'); ?></a> | 
							<a href="<?php _e('http://www.moallemi.ir/en/blog/2010/02/25/feed-delay-for-wordpress/', 'comments-on-feed'); ?>"><?php _e('More Information', 'comments-on-feed'); ?></a>)
						</li>
						<li><b>- <?php _e('Contact Commenter ', 'comments-on-feed'); ?></b> 
							(<a href="http://wordpress.org/extend/plugins/contact-commenter/"><?php _e('Download', 'comments-on-feed'); ?></a> | 
							<a href="<?php _e('http://www.moallemi.ir/blog/1388/12/27/%d9%87%d8%af%db%8c%d9%87-%da%a9%d8%a7%d9%88%d8%b4%da%af%d8%b1-%d9%85%d9%86%d8%a7%d8%b3%d8%a8%d8%aa-%d8%b3%d8%a7%d9%84-%d9%86%d9%88-%d9%88%d8%b1%d8%af%d9%be%d8%b1%d8%b3/', 'comments-on-feed'); ?>"><?php _e('More Information', 'comments-on-feed'); ?></a>)
						</li>
					</ul>
				</div>
			</form>
		</div>
		<?php
	}
							

	$plugin = plugin_basename(__FILE__); 
	add_filter("plugin_action_links_$plugin", 'comments_on_feed_links' );
	
	function comments_on_feed_links($links)
	{ 
		$settings_link = '<a href="options-general.php?page=comments-on-feed">'.__('Settings', 'comments-on-feed').'</a>';
		array_unshift($links, $settings_link); 
		return $links; 
	}
	
	function add_comments_to_feed($content)
	{
		if (!is_feed()) 
			return $content;
		$comments_on_feed_options = get_comments_on_feed_options();
		global $post, $id;
		$option = array('post_id' => $id, 'order' => $comments_on_feed_options['comment_order'], 'status' => 'approve');
		$comments = get_comments($option);
		$count = 0;
		$comment_number = $comments_on_feed_options['comment_number'];
		$str_cmnt_num = get_comment_count($id);
		$more_num = $str_cmnt_num['approved'] - $comment_number;
		$template_path = get_option('siteurl').'/wp-content/plugins/'.plugin_basename(dirname(__FILE__)) .'/comments-template.php?id='.$id;
		if ($str_cmnt_num['approved']!= 0)
		{ 
			$comments_to_add = '
				<div style="border-size:1px;">
					<h4>'.$str_cmnt_num['approved'].__(' commnent(s) for this post:', 'comments-on-feed').'</h4>
					  <ol>';
						foreach ($comments as $cmnt)
						{
							if($comment_number != 0 and $count == $comment_number) 
								break; 
							global $comment;
							$comment = $cmnt;
							$comments_to_add .= '
						  <li>';
							if ($comments_on_feed_options['show_avatar'] == 'true') 
							$comments_to_add .= get_avatar($comment, $comments_on_feed_options['avatar_size']).'
							<i>'.$comment->comment_author.':</i>
							<br />
							<small><a rel="nofollow" href="'.get_comment_link().'">'.$comment->comment_date.'</a></small>
							'.$comment->comment_content.'
						  </li>';
							$count++;
						}
					  $comments_to_add .= '
					  </ol>';
					  $comments_to_add .='
					  <p>
					  <b><a target="_blank" href="'.$template_path.'">'.__('Write a quick comment here', 'comments-on-feed').'</a></b>';
					  if($more_num > 0 )
					  {
						$comments_to_add .= __(' | View ', 'comments-on-feed');
						$comments_to_add .= "<a href='".get_comments_link()."'>$more_num";
						$comments_to_add .= __(" more comment(s).", 'comments-on-feed').'</a>';
					  }
					  $comments_to_add .= '</p>
				  </div>';
		
		}
		return $content.$comments_to_add;
	}
	
	CommentsOnFeed();
			
?>
